#!/usr/bin/env python

class Branch:
    def __init__(self, nodes):
        self.nodes = nodes

    def visit(self, visitor):
        return visitor.visitBranch(self)

class Leaf:
    def __init__(self, value):
        self.value = value

    def visit(self, visitor):
        return visitor.visitLeaf(self)

class Visitor:
    def visit(self, node):
        return node.visit(self)

    # Visitor-specific functionality.

    def visitBranch(self, node):
        sum = 0
        for node in node.nodes:
            sum += self.visit(node)
        return sum

    def visitLeaf(self, node):
        return node.value

tree = \
    Branch((
        Branch((
            Leaf(10),
            Leaf(5)
            )),
        Leaf(2)
        ))

visitor = Visitor()
result_17 = visitor.visit(tree)

# vim: tabstop=4 expandtab shiftwidth=4
